<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../../favicon.png">
  <title>Built-in operators | ToolDef documentation</title>
  <link rel="stylesheet" href="../../assets/asciidoctor-escet-tooldef.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../../assets/asciidoctor-escet-tooldef.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">ToolDef website</a></p>
    <div id="toctitle">
     ToolDef documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation.html">Home</a></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../introduction.html">Introduction</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html">Language reference</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#syntax">Syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../syntax/lexical.html">Lexical syntax</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#keywords">Keywords</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#terminals">Terminals</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#whitespace">Whitespace</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#comments">Comments</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../syntax/grammar.html">Grammar</a></li>
        </ul></li>
       <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a>
        <ul class="sectlevel3">
         <li class="toc-cur-page toc-item toc-item-parent expanded">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Built-in operators</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#not-operator">not operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#and-operator">and operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#or-operator">or operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator-unary1">+ operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator-binary1">+ operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator-unary2">- operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator-binary2">- operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator1">* operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator2">/ operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#div-operator">div operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#mod-operator">mod operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator3">&lt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator4">&lt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator5">&gt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator6">&gt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator7">== operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#operator8">!= operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="data.html">Built-in data tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#abs-tool">abs tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ceil-tool">ceil tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#contains-tool">contains tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#del-tool">del tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#delidx-tool">delidx tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#empty-tool">empty tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#endswith-tool">endswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#entries-tool">entries tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#enumerate-tool">enumerate tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#floor-tool">floor tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#fmt-tool">fmt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#indexof-tool">indexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#join-tool">join tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#keys-tool">keys tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#lastindexof-tool">lastindexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ln-tool">ln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#log-tool">log tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#lower-tool">lower tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ltrim-tool">ltrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#max-tool">max tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#min-tool">min tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#pow-tool">pow tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#range-tool">range tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#replace-tool">replace tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#reverse-tool">reverse tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#round-tool">round tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#rtrim-tool">rtrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#size-tool">size tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#sorted-tool">sorted tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#split-tool">split tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#sqrt-tool">sqrt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#startswith-tool">startswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#str-tool">str tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#strdup-tool">strdup tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#subset-tool">subset tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#trim-tool">trim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#upper-tool">upper tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#values-tool">values tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="io.html">Built-in I/O tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#out-tool">out tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#err-tool">err tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#outln-tool">outln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#errln-tool">errln tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="generic.html">Built-in generic tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#app-tool">app tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#exec-tool">exec tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#tooldef-tool">tooldef tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="path.html">Built-in path tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#abspath-tool">abspath tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#basename-tool">basename tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#chdir-tool">chdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#chfileext-tool">chfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#curdir-tool">curdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#dirname-tool">dirname tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#fileext-tool">fileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#hasfileext-tool">hasfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#pathjoin-tool">pathjoin tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#scriptpath-tool">scriptpath tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="file.html">Built-in file tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#cpfile-tool">cpfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#cpdir-tool">cpdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#diff-tool">diff tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#exists-tool">exists tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#filenewer-tool">filenewer tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#filesize-tool">filesize tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#find-tool">find tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#isdir-tool">isdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#isfile-tool">isfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mkdir-tool">mkdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mvfile-tool">mvfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#mvdir-tool">mvdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#readlines-tool">readlines tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#rmfile-tool">rmfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#rmdir-tool">rmdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="file.html#writefile-tool">writefile tool</a></li>
          </ul></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../interpreter.html">ToolDef interpreter</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#command-line">Command line</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../interpreter.html#escet-ide">ESCET IDE</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../release-notes.html">ToolDef release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-6-0">Version 6.0</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-5-0-2024-10-03">Version 5.0 (2024-10-03)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-4-0-2024-06-30">Version 4.0 (2024-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../../documentation.html">ToolDef documentation</a> &gt; <a class="breadcrumb" href="../index.html">Language reference</a> &gt; <a class="breadcrumb" href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a> &gt; <span class="breadcrumb">Built-in operators</span>
   </div>
   <h2 id="built-in-operators"><a class="anchor" href="#"></a>Built-in operators</h2>
   <div class="paragraph">
    <p>This page describes the built-in operators:</p>
   </div>
   <div class="ulist">
    <ul>
     <li>
      <p><a href="#not-operator">not</a></p></li>
     <li>
      <p><a href="#and-operator">and</a></p></li>
     <li>
      <p><a href="#or-operator">or</a></p></li>
     <li>
      <p><a href="#operator-unary1">+ (unary)</a></p></li>
     <li>
      <p><a href="#operator-unary2">- (unary)</a></p></li>
     <li>
      <p><a href="#operator-binary1">+ (binary)</a></p></li>
     <li>
      <p><a href="#operator-binary2">- (binary)</a></p></li>
     <li>
      <p><a href="#operator1">*</a></p></li>
     <li>
      <p><a href="#operator2">/</a></p></li>
     <li>
      <p><a href="#div-operator">div</a></p></li>
     <li>
      <p><a href="#mod-operator">mod</a></p></li>
     <li>
      <p><a href="#operator3">&lt;</a></p></li>
     <li>
      <p><a href="#operator4">&lt;=</a></p></li>
     <li>
      <p><a href="#operator5">&gt;</a></p></li>
     <li>
      <p><a href="#operator6">&gt;=</a></p></li>
     <li>
      <p><a href="#operator7">==</a></p></li>
     <li>
      <p><a href="#operator8">!=</a></p></li>
    </ul>
   </div>
   <div class="paragraph">
    <p>The signatures of the operators are given using tool headers, to show the name of the operator, the types of the arguments, and the type of the resulting value. Operators however, can not be used by means of tool invocations. Operators with one argument are put directly before the argument (e.g. <code>not true</code>, <code>-5</code>), while operators with two arguments are put between the arguments (e.g. <code>true and false</code>, <code>1 + 3</code>).</p>
   </div>
   <div class="sect4">
    <h3 id="not-operator"><a class="anchor" href="#not-operator"></a>not operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool not(bool arg)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the logical inverse of a boolean value.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>arg</code>
      </dt>
      <dd>
       <p>The boolean value.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The logical inverse result.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="and-operator"><a class="anchor" href="#and-operator"></a>and operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool  and(bool left, bool right)
tool set T and&lt;T&gt;(set T left, set T right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the conjunction of two boolean values, or the intersection of two sets. For boolean values, the operator uses short circuit evaluation. That is, the <code>right</code> argument is only evaluated if necessary, i.e. only if the <code>left</code> argument evaluates to <code>true</code>.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the set.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first boolean value or set.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second boolean value or set.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The conjunction or intersection result.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="or-operator"><a class="anchor" href="#or-operator"></a>or operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool  or(bool left, bool right)
tool set T or&lt;T&gt;(set T left, set T right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the disjunction of two boolean values, or the union of two sets. For boolean values, the operator uses short circuit evaluation. That is, the <code>right</code> argument is only evaluated if necessary, i.e. only if the <code>left</code> argument evaluates to <code>false</code>.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the set.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first boolean value or set.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second boolean value or set.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The disjunction or union result.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator-unary1"><a class="anchor" href="#operator-unary1"></a>+ operator (unary)</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int    +(int arg)
tool long   +(long arg)
tool double +(double arg)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the unary plus of an integer, long, or double value. This is essentially the <a href="https://en.wikipedia.org/wiki/Identity_function">identity function</a>.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>arg</code>
      </dt>
      <dd>
       <p>The integer, long, or double value.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The integer, long, or double value.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator-binary1"><a class="anchor" href="#operator-binary1"></a>+ operator (binary)</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int      +(int left, int right)
tool long     +(long left, long right)
tool double   +(double left, double right)
tool string   +(string left, string right)
tool list T   +&lt;T&gt;(list T left, list T right)
tool map(K:V) +&lt;K, V&gt;(map(K:V) left, map(K:V) right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the addition of two integer, long, or double numbers, the concatenation of two strings or lists, or the update of a first map with the entries of a second map. For two maps, essentially, the entries of the first map are overwritten by the entries of the second map, while entries for new keys are added.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list.</p>
      </dd>
      <dt class="hdlist1">
       <code>K</code>
      </dt>
      <dd>
       <p>The type of the keys of the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>V</code>
      </dt>
      <dd>
       <p>The type of the values of the map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first integer, long, or double number, string, list, or map.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second integer, long, or double number, string, list, or map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The addition, concatenation, or map update result.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow (for integer, long, and double numbers only).</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator-unary2"><a class="anchor" href="#operator-unary2"></a>- operator (unary)</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int    -(int arg)
tool long   -(long arg)
tool double -(double arg)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the negation of an integer, long, or double value.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>arg</code>
      </dt>
      <dd>
       <p>The integer, long, or double value.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The negation result.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator-binary2"><a class="anchor" href="#operator-binary2"></a>- operator (binary)</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int      -(int left, int right)
tool long     -(long left, long right)
tool double   -(double left, double right)
tool set T    -&lt;T&gt;(set T left, set T right)
tool map(K:V) -&lt;K, V&gt;(map(K:V) left, list K right)
tool map(K:V) -&lt;K, V&gt;(map(K:V) left, set K right)
tool map(K:V) -&lt;K, V, V2&gt;(map(K:V) left, map(K:V2) right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the subtraction of two integer, long, or double numbers, the set difference of two sets, the map with the keys from the list removed from it, the map with the keys from the set removed from it, or the first map with the keys from the second map removed from it.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the elements of the list.</p>
      </dd>
      <dt class="hdlist1">
       <code>K</code>
      </dt>
      <dd>
       <p>The type of the keys of the map.</p>
      </dd>
      <dt class="hdlist1">
       <code>V</code>
      </dt>
      <dd>
       <p>The type of the values of the map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first integer, long, or double number, the first set, or the (first) map.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second integer, long, or double number, the (second) set, the list, or the second map.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The subtraction, set difference, or map removal result.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow (for integer, long, and double numbers only).</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator1"><a class="anchor" href="#operator1"></a>* operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int    *(int left, int right)
tool long   *(long left, long right)
tool double *(double left, double right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the multiplication of two integer, long, or double numbers.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first integer, long, or double number.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second integer, long, or double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The multiplication result.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator2"><a class="anchor" href="#operator2"></a>/ operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool double /(double left, double right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the division of two double numbers.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first double number.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The division result.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow or division by zero.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="div-operator"><a class="anchor" href="#div-operator"></a>div operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int  div(int left, int right)
tool long div(long left, long right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the integer division of two integer or long numbers.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first integer or long number.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second integer or long number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The integer division result.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in overflow or division by zero.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="mod-operator"><a class="anchor" href="#mod-operator"></a>mod operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool int  mod(int left, int right)
tool long mod(long left, long right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the modulus of two integer or long numbers.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first integer or long number.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second integer or long number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The modulus result.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>If the operation results in division by zero.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator3"><a class="anchor" href="#operator3"></a>&lt; operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool &lt;(int left, int right)
tool bool &lt;(long left, long right)
tool bool &lt;(double left, double right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether the first integer, long, or double number is less than the second integer, long, or double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first integer, long, or double number.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second integer, long, or double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the first number is less than the second number, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator4"><a class="anchor" href="#operator4"></a>&lt;= operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool &lt;=(int left, int right)
tool bool &lt;=(long left, long right)
tool bool &lt;=(double left, double right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether the first integer, long, or double number is less than or equal to the second integer, long, or double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first integer, long, or double number.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second integer, long, or double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the first number is less than or equal to the second number, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator5"><a class="anchor" href="#operator5"></a>&gt; operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool &gt;(int left, int right)
tool bool &gt;(long left, long right)
tool bool &gt;(double left, double right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether the first integer, long, or double number is greater than the second integer, long, or double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first integer, long, or double number.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second integer, long, or double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the first number is greater than the second number, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator6"><a class="anchor" href="#operator6"></a>&gt;= operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool &gt;=(int left, int right)
tool bool &gt;=(long left, long right)
tool bool &gt;=(double left, double right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether the first integer, long, or double number is greater than or equal to the second integer, long, or double number.</p>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first integer, long, or double number.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second integer, long, or double number.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the first number is greater than or equal to the second number, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator7"><a class="anchor" href="#operator7"></a>== operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool ==&lt;T&gt;(T left, T right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether the first value is equal to the second value.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the values.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first value. May be <code>null</code>.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second value. May be <code>null</code>.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the first value is equal to the second value, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="operator8"><a class="anchor" href="#operator8"></a>!= operator</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool !=&lt;T&gt;(T left, T right)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns whether the first value is unequal to the second value.</p>
    </div>
    <div class="paragraph">
     <p><em>Type parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>T</code>
      </dt>
      <dd>
       <p>The type of the values.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Arguments</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>left</code>
      </dt>
      <dd>
       <p>The first value. May be <code>null</code>.</p>
      </dd>
      <dt class="hdlist1">
       <code>right</code>
      </dt>
      <dd>
       <p>The second value. May be <code>null</code>.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the first value is unequal to the second value, <code>false</code> otherwise.</p>
    </div>
   </div>
  </div>
  <script src="../../assets/highlight.min.js"></script>
  <script src="../../assets/languages/asciidoc.min.js"></script>
  <script src="../../assets/languages/bash.min.js"></script>
  <script src="../../assets/languages/bnf.min.js"></script>
  <script src="../../assets/languages/c.min.js"></script>
  <script src="../../assets/languages/chi.min.js"></script>
  <script src="../../assets/languages/cif.min.js"></script>
  <script src="../../assets/languages/console.min.js"></script>
  <script src="../../assets/languages/css.min.js"></script>
  <script src="../../assets/languages/dsm.min.js"></script>
  <script src="../../assets/languages/java.min.js"></script>
  <script src="../../assets/languages/javascript.min.js"></script>
  <script src="../../assets/languages/markdown.min.js"></script>
  <script src="../../assets/languages/mcrl2.min.js"></script>
  <script src="../../assets/languages/none.min.js"></script>
  <script src="../../assets/languages/plcst.min.js"></script>
  <script src="../../assets/languages/properties.min.js"></script>
  <script src="../../assets/languages/raildiagram.min.js"></script>
  <script src="../../assets/languages/setext.min.js"></script>
  <script src="../../assets/languages/shell.min.js"></script>
  <script src="../../assets/languages/tooldef.min.js"></script>
  <script src="../../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>ToolDef documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v6.0-M1</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>